function Perl_SetupFrame(argFrame)
	argFrame:SetBackdropBorderColor(Perl_Config.BorderColour.r, Perl_Config.BorderColour.g, Perl_Config.BorderColour.b, Perl_Config.Transparency);
	argFrame:SetBackdropColor(Perl_Config.BackColour.r, Perl_Config.BackColour.g, Perl_Config.BackColour.b, Perl_Config.Transparency);
end

local function SetAllFrames()
	Perl_SetupFrame(Perl_Player_Pet_StatsFrame);
	Perl_SetupFrame(Perl_Player_Pet_LevelFrame);
        Perl_SetupFrame(Perl_Player_Pet_HappyFrame);
	Perl_SetupFrame(Perl_Player_Pet_NameFrame);
	Perl_SetupFrame(Perl_Player_Pet_BuffFrame);
	Perl_Player_Pet_HealthBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Player_Pet_ManaBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);

	Perl_SetupFrame(Perl_Player_StatsFrame);
	Perl_SetupFrame(Perl_Player_PortraitFrame);
	Perl_SetupFrame(Perl_Player_NameFrame);
	Perl_SetupFrame(Perl_Player_LevelFrame);
	Perl_SetupFrame(Perl_Player_GroupFrame);
	Perl_Player_ClassTexture:SetAlpha(Perl_Config.Transparency);
	Perl_Player_HealthBarText:SetTextColor(1,1,1,1);
	Perl_Player_ManaBarText:SetTextColor(1,1,1,1);
	Perl_Player_DruidBarText:SetTextColor(1,1,1,1);
	Perl_Player_HealthBarTEXT:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Player_ManaBarTEXT:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Player_XPBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Player_PVPRankIcon:SetAlpha(0.3);

	Perl_SetupFrame(Perl_TargetTarget_StatsFrame);
	Perl_SetupFrame(Perl_TargetTarget_NameFrame);
	Perl_SetupFrame(Perl_TargetTarget_LevelFrame);
	--Perl_TargetTarget_Frame:Hide();
	Perl_TargetTarget_HealthBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_TargetTarget_ManaBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_TargetTarget_ManaBarPercent:SetTextColor(1,1,1,1);
	Perl_TargetTarget_HealthBarPercent:SetTextColor(1,1,1,1);

	Perl_SetupFrame(Perl_Target_StatsFrame);
	Perl_SetupFrame(Perl_Target_NameFrame);
	Perl_SetupFrame(Perl_Target_PortraitFrame);
	Perl_SetupFrame(Perl_Target_BuffFrame);
	Perl_SetupFrame(Perl_Target_LevelFrame);
        Perl_SetupFrame(Perl_Target_AssistFrame);
        --Perl_Target_AssistBarText:SetTextColor(0.5,1,0.5,1);
        Perl_SetupFrame(Perl_Player_TargettingFrame);
        --Perl_Player_TargettingBarText:SetTextColor(0.5,1,0.5,1);
	Perl_SetupFrame(Perl_Target_TypeFrame);
	Perl_SetupFrame(Perl_Target_BossFrame);
	Perl_SetupFrame(Perl_Target_Assists_Frame);

	Perl_SetupFrame(Perl_Target_CPFrame);
	--Perl_Target_Frame:Hide();
	Perl_Target_ClassTexture:SetAlpha(Perl_Config.Transparency);
	Perl_Target_HealthBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Target_ManaBarText:SetTextColor(1,1,1,Perl_Config.TextTransparency);
	Perl_Target_ManaBarPercent:SetTextColor(1,1,1,1);
	Perl_Target_HealthBarPercent:SetTextColor(1,1,1,1);
	Perl_Target_PVPRankIcon:SetAlpha(0.3);
        Perl_TargetTarget_PVPRankIcon:SetAlpha(0.3);
	for num=1,4 do
		Perl_SetupFrame(getglobal("Perl_party"..num.."_StatsFrame"));
		Perl_SetupFrame(getglobal("Perl_party"..num.."_NameFrame"));
		Perl_SetupFrame(getglobal("Perl_party"..num.."_LevelFrame"));
		Perl_SetupFrame(getglobal("Perl_party"..num.."_BuffFrame"));
		getglobal("Perl_party"..num.."_LevelFrame_ClassTexture"):SetAlpha(Perl_Config.Transparency);

		getglobal("Perl_party"..num.."_StatsFrame_HealthBar_HealthBarText"):SetTextColor(1,1,1,Perl_Config.TextTransparency);
		getglobal("Perl_party"..num.."_StatsFrame_ManaBar_ManaBarText"):SetTextColor(1,1,1,Perl_Config.TextTransparency);
		getglobal("Perl_party"..num.."_StatsFrame_HealthBar_HealthBarPercentText"):SetTextColor(1,1,1,1);
		getglobal("Perl_party"..num.."_StatsFrame_ManaBar_ManaBarPercentText"):SetTextColor(1,1,1,1);

		Perl_SetupFrame(getglobal("Perl_party"..num.."_TargetFrame"));

		Perl_SetupFrame(getglobal("Perl_Party_Pet"..num.."_StatsFrame"));
		Perl_SetupFrame(getglobal("Perl_Party_Pet"..num.."_NameFrame"));
		Perl_SetupFrame(getglobal("Perl_Party_Pet"..num.."_BuffFrame"));

		getglobal("Perl_Party_Pet"..num.."_StatsFrame_HealthBar_HealthBarPercentText"):SetTextColor(1,1,1,1);
		getglobal("Perl_Party_Pet"..num.."_StatsFrame_ManaBar_ManaBarPercentText"):SetTextColor(1,1,1,1);

		if (UnitName("party"..num) and not UnitIsConnected("party"..num)) then
			getglobal("Perl_party"..num):SetAlpha(Perl_Config.Transparency / 2);
		end

		if (Perl_Config.HighlightSelection == 1) then
			getglobal("Perl_party"..num.."_NameFrame_CastClickOverlay"):SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight2x1", "ADD");
			getglobal("Perl_party"..num.."_TargetFrame_TargetCastClickOverlay"):SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight4x1", "ADD");
			getglobal("Perl_Party_Pet"..num.."_CastClickOverlay"):SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight2x1", "ADD");
		else
			getglobal("Perl_party"..num.."_NameFrame_CastClickOverlay"):SetHighlightTexture("");
			getglobal("Perl_party"..num.."_TargetFrame_TargetCastClickOverlay"):SetHighlightTexture("");
			getglobal("Perl_Party_Pet"..num.."_CastClickOverlay"):SetHighlightTexture("");
		end
	end

	if (Perl_Config.HighlightSelection == 1) then
		Perl_Player_CastClickOverlay:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight4x1", "ADD");
		Perl_Player_TargettingFrame:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight2x1", "ADD");
		Perl_Player_Pet_CastClickOverlay:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight2x1", "ADD");
		Perl_Target_CastClickOverlay:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight4x1", "ADD");
		Perl_Target_AssistFrame:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight2x1", "ADD");
		Perl_TargetTarget_CastClickOverlay:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight4x1", "ADD");
	else
		Perl_Player_CastClickOverlay:SetHighlightTexture("");
		Perl_Player_TargettingFrame:SetHighlightTexture("");
		Perl_Player_Pet_CastClickOverlay:SetHighlightTexture("");
		Perl_Target_CastClickOverlay:SetHighlightTexture("");
		Perl_Target_AssistFrame:SetHighlightTexture("");
		Perl_TargetTarget_CastClickOverlay:SetHighlightTexture("");
	end

	for num=1,10 do
		Perl_SetupFrame(getglobal("Perl_TargetTarget_History"..num));
	end
	Perl_SetupFrame(Perl_TargetTarget_HistoryLast);

	if (Perl_SetupRaidFrames) then
		Perl_SetupRaidFrames();
	end
end

function Perl_Init()
	SetAllFrames();

	Perl_Player_Frame:Show();
	Perl_Player_XPBarText:Hide();
	Perl_OptionActions();
	Perl_SlashOnLoad();

	if (EarthFeature_AddButton) then
		local button = {}
		button.name = Perl_ProductName;
		button.icon = Perl_ModMenuIcon;
		button.subtext = "By "..Perl_Author;
		button.tooltip = Perl_LongDescription;
		button.callback = Perl_Toggle;
		EarthFeature_AddButton (button);
	end

	if(CT_RegisterMod) then
		CT_RegisterMod(Perl_Version, "By "..Perl_Author, 4, Perl_ModMenuIcon, Perl_LongDescription, "switch", "", Perl_Toggle);
	end

	if (myAddOnsFrame) then
                myAddOnsList.Perl_Description = {
                        name			= Perl_Description,
                        description		= "Modifies the default party and target frames.",
                        version			= Perl_VersionNumber,
                        category		= MYADDONS_CATEGORY_OTHERS,
                        frame			= "Perl_Frame",
                        optionsframe		= "Perl_FrameOptions_Frame"
                        };
	end
end

function Perl_OptionActions()
	if (Perl_Config.ShowPlayerPortrait==0) then
		Perl_Player_Hide_Portrait();
	elseif (Perl_Config.ShowPlayerPortrait==1) then
		Perl_Player_Show_Portrait();
	end
	if (Perl_Config.ShowPlayerLevel==0) then
		Perl_Player_Hide_Level();
	elseif (Perl_Config.ShowPlayerLevel==1) then
		Perl_Player_Show_Level();
	end
	if (Perl_Config.ShowPlayerClassIcon==0) then
		Perl_Player_Hide_Class();
	elseif (Perl_Config.ShowPlayerClassIcon==1) then
		Perl_Player_Show_Class();
	end
	if (Perl_Config.ShowPlayerXPBar==0) then
		Perl_Player_Hide_XPBar();
	elseif (Perl_Config.ShowPlayerXPBar==1) then
		Perl_Player_Show_XPBar();
	end
	if (Perl_Config.ShowTargetPortrait==0) then
		Perl_Target_Hide_Portrait();
	elseif (Perl_Config.ShowTargetPortrait==1) then
		Perl_Target_Show_Portrait();
	end
	if (Perl_Config.ShowTargetClassIcon==0) then
		Perl_Target_Hide_Class();
	elseif (Perl_Config.ShowTargetClassIcon==1) then
		Perl_Target_Show_Class();
	end
	if (Perl_Config.ShowTargetMobType==0) then
		Perl_Target_Hide_Type();
	elseif (Perl_Config.ShowTargetMobType==1) then
		Perl_Target_Show_Type();
	end
	if (Perl_Config.ShowTargetLevel==0) then
		Perl_Target_Hide_Level();
	elseif (Perl_Config.ShowTargetLevel==1) then
		Perl_Target_Show_Level();
	end
	if (Perl_Config.ShowTargetElite==0) then
		Perl_Target_Hide_Elite();
	elseif (Perl_Config.ShowTargetElite==1) then
		Perl_Target_Show_Elite();
	end
	if (Perl_Config.ShowTargetMana==0) then
		Perl_Target_Hide_Mana();
	elseif (Perl_Config.ShowTargetMana==1) then
		Perl_Target_Show_Mana();
	end
	if (Perl_Config.ShowPartyClassIcon==0) then
		Perl_HidePartyIcon();
	elseif (Perl_Config.ShowPartyClassIcon==1) then
		Perl_ShowPartyIcon();
	end
	if (Perl_Config.ShowPartyLevel==0) then
		Perl_HidePartyLevel();
	elseif (Perl_Config.ShowPartyLevel==1) then
		Perl_ShowPartyLevel();
	end
	if (Perl_Config.ShowPartyNames==0) then
		Perl_HidePartyNames();
	elseif (Perl_Config.ShowPartyNames==1) then
		Perl_ShowPartyNames();
	end
	if (Perl_Config.ShowPartyPercent==0) then
		Perl_HidePartyPercent();
	elseif (Perl_Config.ShowPartyPercent==1) then
		Perl_ShowPartyPercent();
	end
	if (Perl_Config.PetHappiness==0) then
		Perl_Player_Pet_HideHappiness();
	elseif (Perl_Config.PetHappiness==1) then
		Perl_Player_Pet_ShowHappiness();
	end
	if (Perl_Config.ShowPetLevel==0) then
		Perl_Player_Pet_HideLevel();
	elseif (Perl_Config.ShowPetLevel==1) then
		Perl_Player_Pet_ShowLevel();
	end
	if (Perl_Config.ShowTargetPVPRank==0) then
		Perl_Target_Hide_Rank();
	elseif (Perl_Config.ShowTargetPVPRank==1) then
		Perl_Target_Show_Rank();
	end
	if (Perl_Config.ShowPlayerPVPRank==0) then
		Perl_Player_Hide_Rank();
	elseif (Perl_Config.ShowPlayerPVPRank==1) then
		Perl_Player_Show_Rank();
	end
	if (Perl_Config.BarTextures==0) then
		Perl_NoBarTextures();
	elseif (Perl_Config.BarTextures==1) then
		Perl_ShowBarTextures();
	end

	Perl_Config.Transparency=tonumber(Perl_Config.Transparency);
	if type(Perl_Config.Transparency) == "number" and Perl_Config.Transparency>= 0 and Perl_Config.Transparency<= 1 then

		Perl_SetTransparency(Perl_Config.Transparency);
	else
		Perl_Config.Transparency=1;
	end

	Perl_Config.TextTransparency=tonumber(Perl_Config.TextTransparency);
	if type(Perl_Config.TextTransparency) == "number" and Perl_Config.TextTransparency>= 0 and Perl_Config.TextTransparency<= 1 then

		Perl_SetTextTransparency(Perl_Config.TextTransparency);
	else
		Perl_Config.TextTransparency=1;
	end

	Perl_Config.Scale_PlayerFrame=tonumber(Perl_Config.Scale_PlayerFrame);
	if type(Perl_Config.Scale_PlayerFrame) == "number" and Perl_Config.Scale_PlayerFrame >= 0.5 and Perl_Config.Scale_PlayerFrame<= 1.5 then
		Perl_ScalePlayer(Perl_Config.Scale_PlayerFrame);
	else
		Perl_Config.Scale_PlayerFrame=0.8;
	end

	Perl_Config.Scale_PetFrame=tonumber(Perl_Config.Scale_PetFrame);
	if type(Perl_Config.Scale_PetFrame) == "number" and Perl_Config.Scale_PetFrame>= 0.5 and Perl_Config.Scale_PetFrame<= 1.5 then

		Perl_ScalePet(Perl_Config.Scale_PetFrame);
	else
		Perl_Config.Scale_PetFrame=0.8;
	end


	Perl_Config.Scale_PartyFrame=tonumber(Perl_Config.Scale_PartyFrame);
	if type(Perl_Config.Scale_PartyFrame) == "number" and Perl_Config.Scale_PartyFrame >= 0.5 and Perl_Config.Scale_PartyFrame <= 1.5 then
		Perl_ScaleParty(Perl_Config.Scale_PartyFrame);
	else
		Perl_Config.Scale_PartyFrame=0.8;
	end

	Perl_Config.Scale_TargetFrame=tonumber(Perl_Config.Scale_TargetFrame);
	if type(Perl_Config.Scale_TargetFrame) == "number" and Perl_Config.Scale_TargetFrame >= 0.5 and Perl_Config.Scale_TargetFrame <= 1.5 then
		Perl_ScaleTarget(Perl_Config.Scale_TargetFrame);
	else
		Perl_Config.Scale_TargetFrame=0.8;
	end

	Perl_Config.Scale_TargetTargetFrame=tonumber(Perl_Config.Scale_TargetTargetFrame);
	if type(Perl_Config.Scale_TargetTargetFrame) == "number" and Perl_Config.Scale_TargetTargetFrame>= 0.5 and Perl_Config.Scale_TargetTargetFrame<= 1.5 then
		Perl_ScaleTargetTarget(Perl_Config.Scale_TargetTargetFrame);
	else
		Perl_Config.Scale_TargetTargetFrame=0.8;
	end

	Perl_Config.Scale_AssistsFrame=tonumber(Perl_Config.Scale_AssistsFrame);
	if type(Perl_Config.Scale_AssistsFrame) == "number" and Perl_Config.Scale_AssistsFrame>= 0.5 and Perl_Config.Scale_AssistsFrame<= 1.5 then
		Perl_ScaleAssistFrame(Perl_Config.Scale_AssistsFrame);
	else
		Perl_Config.Scale_AssistsFrame = 0.8;
	end

	Perl_Config.Scale_Raid=tonumber(Perl_Config.Scale_Raid);
	if type(Perl_Config.Scale_Raid) == "number" and Perl_Config.Scale_Raid >= 0.5 and Perl_Config.Scale_Raid<= 1.5 then
		if (Perl_ScaleRaid) then
			Perl_ScaleRaid(Perl_Config.Scale_Raid);
		end
	else
		Perl_Config.Scale_Raid = 0.8;
	end

	if (Perl_Config.ArcaneBar==0) then
		Perl_ArcaneBar_Hide();
	elseif (Perl_Config.ArcaneBar==1) then
		Perl_ArcaneBar_Show();
	end
	if (Perl_Config.OldCastBar==0) then
		Perl_OldCastBar_Hide();
	elseif (Perl_Config.OldCastBar==1) then
		Perl_OldCastBar_Show();
	end
	if (Perl_Config.ShowOldPlayerFrame==0) then
		Perl_HideBlizzardPlayer();
	elseif (Perl_Config.ShowOldPlayerFrame==1) then
		Perl_ShowBlizzardPlayer();
	end
	if (Perl_Config.CastPartyShow==0) then
		Perl_HideCastParty();
	elseif (Perl_Config.CastPartyShow==1) then
		Perl_ShowCastParty();
	end
	if (Perl_Config.BarTextures==1) then
		Perl_ShowBarTextures();
	elseif (Perl_Config.BarTextures==0) then
		Perl_NoBarTextures();
	end

	Perl_Player_UpdateDisplay();

	for i = 1,4 do
		Perl_Party_UpdateDisplay("party"..i);
		local frame = getglobal("Perl_Party_Pet"..i);
		Perl_Party_Pet_UpdateDisplay(frame);
	end

	Perl_TargetTarget_UpdateDisplay();

	Perl_Player_UpdateLeader();

	if (Perl_Raid_Position) then
		Perl_Raid_Position();
		Perl_RaidTitles();
	end

	if (Perl_Config.ShowRaid == 1) then
		local name, title, notes, enabled = GetAddOnInfo("Perl_RaidFrames");

		if (not enabled) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000X-Perl|r - Raid Frames AddOn was not enabled. Enabling");
			EnableAddOn("Perl_RaidFrames");
			DEFAULT_CHAT_FRAME:AddMessage("    (Raid frames will be available after a relog or /console reloadui)");
		end
	end

	SetAllFrames();
end
