--PerlCounters = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}

local Perl_Raid_Events = {}
local flashID;

----------------------
-- Loading Function --
----------------------

function Perl_Raid_OnLoad()

--DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000X-Perl|r - Loading Raid Frames Addon");

	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	this:RegisterEvent("ADDON_LOADED");

	this.Array = {};
end

function Perl_Raid_Group_OnLoad()
	if (Perl_Config.RaidPositions) then
		local pos = Perl_Config.RaidPositions[this:GetName()];

		if (pos) then
			if (pos.left or pos.right) then
				this:ClearAllPoints();
				this:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", pos.left, pos.top);
			end
		end
	end

	function this:SavePosition()
		Perl_Config.RaidPositions[this:GetName()] = {["top"] = this:GetTop(), ["left"] = this:GetLeft()};
	end

	function this:SaveAllPositions()
		for i = 1,9 do
			local name = "Perl_Raid_Grp"..i;
			local frame = getglobal(name);
			Perl_Config.RaidPositions[name] = {["top"] = frame:GetTop(), ["left"] = frame:GetLeft()};
		end
	end
end

function Perl_Raid_Single_OnLoad(bWarrior)
	this.partyid = "raid"..this:GetID();
	this.showing = 0;
	this.time = 0;

	getglobal("Perl_Raid"..this:GetID().."_DropDown"):SetID(this:GetID());
	table.insert(UnitPopupFrames, "Perl_Raid"..this:GetID().."_DropDown");

	Perl_Raid_Frame.Array[this.partyid] = this;

	Perl_SetupFrame(getglobal(this:GetName().."_NameFrame"));
	Perl_SetupFrame(getglobal(this:GetName().."_StatsFrame"));
	getglobal(this:GetName().."_StatsFrame_HealthBar_HealthBarText"):SetTextColor(1,1,1,1);
	getglobal(this:GetName().."_StatsFrame_ManaBar_ManaBarText"):SetTextColor(1,1,1,1);

	getglobal(this:GetName().."_StatsFrame_ManaBar_ManaBarText"):SetFont("GameFontNormalSmall", 6);
	getglobal(this:GetName().."_StatsFrame_ManaBar_ManaBarText"):SetTextHeight(8);

	getglobal(this:GetName().."_StatsFrame_CastClickOverlay"):SetID(this:GetID());
	getglobal(this:GetName().."_StatsFrame_CastClickOverlay"):SetFrameLevel(getglobal(this:GetName().."_NameFrame"):GetFrameLevel() + 2);

	if (Perl_Config.BarTextures==0) then
		getglobal(this:GetName().."_StatsFrame_HealthBar_HealthBarTex"):SetTexture("Interface\\TargetingFrame\\UI-StatusBar");
		getglobal(this:GetName().."_StatsFrame_ManaBar_ManaBarTex"):SetTexture("Interface\\TargetingFrame\\UI-StatusBar");
	else
		getglobal(this:GetName().."_StatsFrame_HealthBar_HealthBarTex"):SetTexture("Interface\\AddOns\\Perl\\Images\\Perl_StatusBar.tga");
		getglobal(this:GetName().."_StatsFrame_ManaBar_ManaBarTex"):SetTexture("Interface\\AddOns\\Perl\\Images\\Perl_StatusBar.tga");
	end
end

local function Perl_Raid_RegisterSome()
	this:RegisterEvent("RAID_ROSTER_UPDATE");
	this:RegisterEvent("UNIT_PVP_UPDATE");
	this:RegisterEvent("UNIT_FLAGS");
	this:RegisterEvent("UNIT_DYNAMIC_FLAGS");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("UNIT_SPELLMISS");
	Perl_RegisterBasics();
	this:UnregisterEvent("UNIT_LEVEL");
end
local function Perl_Raid_UnregisterSome()
	this:UnregisterEvent("RAID_ROSTER_UPDATE");
	this:UnregisterEvent("UNIT_PVP_UPDATE");
	this:UnregisterEvent("UNIT_FLAGS");
	this:UnregisterEvent("UNIT_DYNAMIC_FLAGS");
	this:UnregisterEvent("UNIT_AURA");
	this:UnregisterEvent("UNIT_SPELLMISS");
	Perl_UnregisterBasics();
end

-- Perl_Raid_UpdateName
local function Perl_Raid_UpdateName(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = Perl_Raid_Frame.Array[id];
	end

	if (thisFrame) then
		local name = UnitName(thisFrame.partyid);

		if (name) then
			local frame = getglobal(thisFrame:GetName().."_NameFrame_NameBarText");
			local frameParent = getglobal(thisFrame:GetName().."_NameFrame");

        	        frame:SetText(name);

			local remCount = 1;
			while ((frame:GetStringWidth() >= (frameParent:GetWidth() - 6)) and (string.len(name) > remCount)) do
				name = string.sub(name, 1, string.len(name) - remCount).."..";
				remCount = 3;
				frame:SetText(name);
			end

			Perl_ColourFriendlyUnit(frame, thisFrame.partyid);
		end
	end
end

-- Perl_Raid_UpdateManaType
local function Perl_Raid_UpdateManaType(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = Perl_Raid_Frame.Array[id];
	end

	if (thisFrame) then
		local frame = getglobal(thisFrame:GetName().."_StatsFrame_ManaBar");
		local frameBG = getglobal(thisFrame:GetName().."_StatsFrame_ManaBarBG");

		local power = UnitPowerType(thisFrame.partyid);

		if  (power == 1) then
			frame:SetStatusBarColor(1, 0, 0, 1);
			frameBG:SetStatusBarColor(1, 0, 0, 0.25);
		elseif (power == 2) then
			frame:SetStatusBarColor(1, 0.5, 0, 1);
			frameBG:SetStatusBarColor(1, 0.5, 0, 0.25);
		elseif (power == 3) then
			frame:SetStatusBarColor(1, 1, 0, 1);
			frameBG:SetStatusBarColor(1, 1, 0, 0.25);
		else
			frame:SetStatusBarColor(0, 0, 1, 1);
			frameBG:SetStatusBarColor(0, 0, 1, 0.25);
		end
	end
end

-- Perl_CT_AKF
local function Perl_Raid_CheckFlags(partyid)
	if (CT_RA_Stats) then
		local unitStats = CT_RA_Stats[UnitName(partyid)];
		if (unitStats) then
			if (unitStats["notready"]) then
				if (unitStats["notready"] == 1) then
					return ("No Reply");
				else
					return ("Not Ready");
				end

			elseif (UnitIsDead(partyid) and unitStats["Ressed"]) then
				if (unitStats["Ressed"] == 2) then
					return ("SS Available");
				else
					return ("Resurrected");
				end

			elseif (unitStats["AFK"]) then
				return ("AFK");

			elseif (unitStats["DND"]) then
				return ("DND");
			end
		end
	end

	return (nil);
end

-- Perl_Raid_ShowFlags
local function Perl_Raid_ShowFlags(id, flags)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = Perl_Raid_Frame.Array[id];
	end

	if (thisFrame and thisFrame:GetName()) then
		thisFrame.flags = flags;
		local f;
		f = getglobal(thisFrame:GetName().."_StatsFrame_HealthBar"); if (f) then f:SetStatusBarColor(0.5, 0.5, 0.5, 1); end
		f = getglobal(thisFrame:GetName().."_StatsFrame_HealthBarBG"); if (f) then f:SetStatusBarColor(0.3, 0.3, 0.3, 1); end
		f = getglobal(thisFrame:GetName().."_StatsFrame_ManaBar"); if (f) then f:SetStatusBarColor(0.5, 0.5, 0.5, 1); end
		f = getglobal(thisFrame:GetName().."_StatsFrame_ManaBarBG"); if (f) then f:SetStatusBarColor(0.3, 0.3, 0.3, 1); end
		f = getglobal(thisFrame:GetName().."_StatsFrame_HealthBar_HealthBarText"); if (f) then f:SetText(flags); end
	end
end

-- Perl_Raid_UpdateHealth
local function Perl_Raid_UpdateHealth(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = Perl_Raid_Frame.Array[id];
	end

	if (thisFrame) then
		local health = UnitHealth(thisFrame.partyid);
		local healthmax = UnitHealthMax(thisFrame.partyid);

		local phealthPct = (health * 100.0) / healthmax;
		phealthPct = string.format("%3.0f", phealthPct);

		local frameText = getglobal(thisFrame:GetName().."_StatsFrame_HealthBar_HealthBarText");

		getglobal(thisFrame:GetName().."_StatsFrame_HealthBar"):SetMinMaxValues(0, healthmax);
		getglobal(thisFrame:GetName().."_StatsFrame_HealthBar"):SetValue(health);

		if (UnitName(thisFrame.partyid) and UnitIsConnected(thisFrame.partyid)) then
			local flags = Perl_Raid_CheckFlags(thisFrame.partyid)
			if (flags) then
				Perl_Raid_ShowFlags(thisFrame.partyid, flags);

				if (UnitIsDeadOrGhost(thisFrame.partyid)) then
					Perl_UnitDied(thisFrame);
				end
				return;

			elseif (UnitIsDead(thisFrame.partyid)) then
				Perl_UnitDied(thisFrame);
				frameText:SetText("Dead");

			elseif (UnitIsGhost(thisFrame.partyid)) then
				Perl_UnitDied(thisFrame);
				frameText:SetText("Ghost");

			else
				Perl_UnitAlive(thisFrame);
				frameText:SetText(phealthPct.."%");
			end
		else
			Perl_UnitAlive(thisFrame);
			frameText:SetText("Offline");
		end

		Perl_SetSmoothBarColor(getglobal(thisFrame:GetName().."_StatsFrame_HealthBar"));
		Perl_SetSmoothBarColor(getglobal(thisFrame:GetName().."_StatsFrame_HealthBarBG"),getglobal(thisFrame:GetName().."_StatsFrame_HealthBar"), 0.25);
	end
end

-- Perl_Raid_UpdateMana
local function Perl_Raid_UpdateMana(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = Perl_Raid_Frame.Array[id];
	end

	if (thisFrame) then
		local mana = UnitMana(thisFrame.partyid);
		local manamax = UnitManaMax(thisFrame.partyid);

		if (UnitPowerType(thisFrame.partyid) == 0) then
			local pmanaPct = (mana * 100.0) / manamax;
			getglobal(thisFrame:GetName().."_StatsFrame_ManaBar_ManaBarText"):SetText(string.format("%3.0f%%", pmanaPct));
		else
			getglobal(thisFrame:GetName().."_StatsFrame_ManaBar_ManaBarText"):SetText("");
		end

		getglobal(thisFrame:GetName().."_StatsFrame_ManaBar"):SetMinMaxValues(0, manamax);
		getglobal(thisFrame:GetName().."_StatsFrame_ManaBar"):SetValue(mana);
	end
end

-- Perl_Party_CombatFlash
local function Perl_Raid_CombatFlash(elapsed, argNew, argGreen)
	local thisFrame = Perl_Raid_Frame.Array[flashID];
	if (thisFrame) then
		if (Perl_CombatFlashSet (elapsed, thisFrame, argNew, argGreen)) then
			Perl_CombatFlashSetFrames(getglobal(thisFrame:GetName().."_NameFrame"), thisFrame.PlayerFlash, thisFrame.PlayerFlashGreen);
			Perl_CombatFlashSetFrames(getglobal(thisFrame:GetName().."_StatsFrame"), thisFrame.PlayerFlash, thisFrame.PlayerFlashGreen);
		end
	end
end

-- Perl_Raid_OnUpdate
function Perl_Raid_OnUpdate(elapsed)
	if (this.PlayerFlash) then
		flashID = this.partyid;
		Perl_Raid_CombatFlash(elapsed, false);
	end

	-- Check flags from CTRA each 1/2 second
	if elapsed then this.time = this.time + elapsed; end
	if this.time >= 0.5 then
		if (UnitIsConnected(this.partyid)) then
			this.time = 0;
			local flags = Perl_Raid_CheckFlags(this.partyid);
			if (flags) then
				Perl_Raid_ShowFlags(this.partyid, flags);
			elseif (this.flags) then
				this.flags = nil;
				Perl_Raid_UpdateHealth();
				Perl_Raid_UpdateManaType();
				Perl_Raid_UpdateMana();
			end
		end
	end

	Perl_UnitDeathSequence();
end

-- Perl_Raid_Warrior_OnUpdate
function Perl_Raid_Warrior_OnUpdate(elapsed)
	if elapsed then
		this.time = this.time + elapsed;
	end
	if this.time >= 0.3 then
		this.time = 0;

		if (this.parentid) then
			if (UnitName(this.parentid)) then
				if UnitName(this.partyid) then
					Perl_Raid_UpdateDisplay();
				end
			else
				this.parentid = nil;
				this.partyid = "";
				this.showing = 0;
				this:Hide();
			end
		end
	end
end

-- Perl_Raid_UpdateBuffs
local function Perl_Raid_UpdateBuffs(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = Perl_Raid_Frame.Array[id];
	end

	if (thisFrame) then
		local class = UnitClass("player");
		local cursed;

		if (class == PERL_LOC_CLASS_MAGE) then
			cursed = Perl_UnitDebuffType(thisFrame.partyid, "Curse");
		elseif (class == PERL_LOC_CLASS_DRUID) then
			cursed = (Perl_UnitDebuffType(thisFrame.partyid, "Curse") or Perl_UnitDebuffType(thisFrame.partyid, "Poison"));
		elseif (class == PERL_LOC_CLASS_PRIEST) then
			cursed = Perl_UnitDebuffType(thisFrame.partyid, "Magic");
		elseif (class == PERL_LOC_CLASS_WARLOCK) then
			cursed = Perl_UnitDebuffType(thisFrame.partyid, "Magic");
		elseif (class == PERL_LOC_CLASS_PALADIN) then
			cursed = (Perl_UnitDebuffType(thisFrame.partyid, "Magic") or Perl_UnitDebuffType(thisFrame.partyid, "Poison") or Perl_UnitDebuffType(thisFrame.partyid, "Disease"));
		elseif (class == PERL_LOC_CLASS_SHAMAN) then
			cursed = (Perl_UnitDebuffType(thisFrame.partyid, "Poison") or Perl_UnitDebuffType(thisFrame.partyid, "Disease"));
		end

		local frameText = getglobal(thisFrame:GetName().."_NameFrame_NameBarText");

		if (cursed) then
			frame:SetTextColor(1,0,0, Perl_Config.TextTransparency);
		else
			Perl_ColourFriendlyUnit(frameText, thisFrame.partyid);
		end
	end
end

local function Perl_Raid_Update_Control(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = Perl_Raid_Frame.Array[id];
	end

	if (thisFrame) then
	        if (UnitIsVisible(thisFrame.partyid) and UnitIsCharmed(thisFrame.partyid)) then
			getglobal(thisFrame:GetName().."_NameFrame_Warning"):Show();
		else
			getglobal(thisFrame:GetName().."_NameFrame_Warning"):Hide();
		end
	end
end


local function Perl_Raid_UpdateCombat(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = Perl_Raid_Frame.Array[id];
	end

	if (thisFrame) then
		local frame = getglobal(thisFrame:GetName().."_NameFrame_ActivityStatus");
		if (not (frame == nil)) then
		        if (UnitName(thisFrame.partyid) and UnitAffectingCombat(thisFrame.partyid)) then
		                frame:Show();
			else
		                frame:Hide();
			end
		end
	end
end

-------------------------
-- The Update Function --
-------------------------
function Perl_Raid_UpdateDisplay(id)

	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = Perl_Raid_Frame.Array[id];
	end

	if (thisFrame and thisFrame.partyid and thisFrame.showing == 1) then
		if (UnitName(thisFrame.partyid) ~= nil) then
			if (UnitIsConnected(thisFrame.partyid)) then
				thisFrame:SetAlpha(Perl_Config.Transparency);
			else
				thisFrame:SetAlpha(Perl_Config.Transparency/2);
				getglobal(thisFrame:GetName().."_StatsFrame_HealthBar_HealthBarText"):SetText("Offine");
			end

			if (Perl_Config.ShowRaidPercents==0) then
				getglobal(thisFrame:GetName().."_StatsFrame_ManaBar_ManaBarText"):Hide();
				getglobal(thisFrame:GetName().."_StatsFrame_HealthBar_HealthBarText"):Hide();
			else
				getglobal(thisFrame:GetName().."_StatsFrame_ManaBar_ManaBarText"):Show();
				getglobal(thisFrame:GetName().."_StatsFrame_HealthBar_HealthBarText"):Show();
			end

			Perl_Raid_UpdateHealth(id);
			Perl_Raid_UpdateManaType(id);
			Perl_Raid_UpdateMana(id);
			Perl_Raid_UpdateName(id);
			Perl_Raid_UpdateCombat(id);
			Perl_Raid_Update_Control(id);
		else
			thisFrame:StopMovingOrSizing();
			thisFrame:Hide();
		end
	else
		thisFrame:StopMovingOrSizing();
		thisFrame:Hide();
	end
end

-------------------
-- Event Handler --
-------------------
function Perl_Raid_OnEvent()
	local func = Perl_Raid_Events[event];
	if (func) then
		func();
	else
Perl_ShowMessage("EXTRA EVENT");
	end
end

function Perl_Raid_Events:ADDON_LOADED()
	if (arg1 == "Perl_RaidFrames") then
		this:UnregisterEvent("ADDON_LOADED");

		Perl_Raid_RegisterSome();

		Perl_ScaleRaid(Perl_Config.Scale_Raid);
		Perl_Raid_Position();
		Perl_RaidTitles();
	end
end

-- PLAYER_ENTERING_WORLD
function Perl_Raid_Events:PLAYER_ENTERING_WORLD()
	Perl_Raid_RegisterSome();
end

-- PLAYER_LEAVING_WORLD
function Perl_Raid_Events:PLAYER_LEAVING_WORLD()
	Perl_Raid_UnregisterSome();
end

-- RAID_ROSTER_UPDATE
function Perl_Raid_Events:RAID_ROSTER_UPDATE()
	Perl_Raid_Position();
end

-- UNIT_FLAGS
function Perl_Raid_Events:UNIT_FLAGS()
	Perl_Raid_UpdateCombat(arg1);
	Perl_Raid_Update_Control(arg1);
end

Perl_Raid_Events.UNIT_DYNAMIC_FLAGS = Perl_Raid_Events.UNIT_FLAGS;

-- UNIT_COMBAT
function Perl_Raid_Events:UNIT_COMBAT()
	if (arg2 == "HEAL") then
		flashID = arg1;
		Perl_Raid_CombatFlash(0, true, true);
	elseif (arg4 and arg4 > 0) then
		flashID = arg1;
		Perl_Raid_CombatFlash(0, true);
	end
end

-- UNIT_HEALTH
function Perl_Raid_Events:UNIT_HEALTH()
	Perl_Raid_UpdateHealth(arg1);
	Perl_Raid_UpdateCombat(arg1);
end
Perl_Raid_Events.UNIT_MAXHEALTH = Perl_Raid_Events.UNIT_HEALTH;

function Perl_Raid_Events:UNIT_DISPLAYPOWER()
	Perl_Raid_UpdateManaType(arg1);
	Perl_Raid_UpdateMana(arg1);
end

-- UNIT_MANA
function Perl_Raid_Events:UNIT_MANA()
	Perl_Raid_UpdateMana(arg1);
end
Perl_Raid_Events.UNIT_MAXMANA   = Perl_Raid_Events.UNIT_MANA;
Perl_Raid_Events.UNIT_RAGE      = Perl_Raid_Events.UNIT_MANA;
Perl_Raid_Events.UNIT_MAXRAGE   = Perl_Raid_Events.UNIT_MANA;
Perl_Raid_Events.UNIT_ENERGY    = Perl_Raid_Events.UNIT_MANA;
Perl_Raid_Events.UNIT_MAXENERGY = Perl_Raid_Events.UNIT_MANA;
Perl_Raid_Events.UNIT_FOCUS     = Perl_Raid_Events.UNIT_MANA;
Perl_Raid_Events.UNIT_MAXFOCUS  = Perl_Raid_Events.UNIT_MANA;

-- UNIT_NAME_UPDATE
function Perl_Raid_Events:UNIT_NAME_UPDATE()
	Perl_Raid_UpdateName(arg1);
end

function Perl_Raid_Events:UNIT_AURA()
	Perl_Raid_UpdateBuffs(arg1);
end

--------------------
-- Raid Functions --
--------------------
function Perl_Raid_Position()
	local p=1;
	if (Perl_Config.SortRaidByClass==1) then
		Perl_Raid_Classes();
	else
		Perl_Raid_Groups();
	end
	Perl_Raid_Grp9_NameFrame_NameBarText:SetText("Targets");

	-- put target ones under their lineup frames
	if (Perl_Config.ShowGroup9) then
		for num=41,50 do
			local frame = getglobal("Perl_Raid"..num);

			if (not UnitInRaid(frame.partyid)) then
				frame.partyid = "";
				frame.parentid = nil;
				frame:Hide();
				frame.showing = 0;
			else
				--frame:SetPoint("TOPLEFT", "Perl_Raid_Grp9", "BOTTOMLEFT", 0,(2-((num-41)*44)));
				if (frame.partyid ~= "") then
					if (UnitName(frame.partyid.."target")) then
						frame:Show();
					else
						frame:Hide();
					end
					if (Perl_Config.ShowGroup9==0) then
						frame.showing = 0;
					else
						frame.showing = 1;
					end
				else
					frame:Hide();
					frame.showing = 0;
					frame.parentid = nil;
				end
			end
		end
	end

	if Perl_Config.ShowRaid == 0 then
		Perl_Raid_All:Hide();
	else
		-- This single line can take 1 second+..... why?
		-- However, it's better than then 0.1 second PER RAID FRAME that we had when everything was a child of UIParent
		Perl_Raid_All:Show();

		for num=1,50 do
			local frame = getglobal("Perl_Raid"..num);

			if (frame.showing == 1) then
				frame:Show();
				if (num <= 40) then
					Perl_Raid_UpdateDisplay(frame.partyid);
				end
			else
				frame:Hide();
			end
		end
	end

	for i = 1,9 do
		local frame = getglobal("Perl_Raid_Grp"..i);
		if (perl_locked == 1) then
			frame:Hide();
		else
			frame:Show();
		end
	end
end

function Perl_Raid_Classes()
	local wpos=1;
	local wa=0;
	local m=0;
	local p=0;
	local wr=0;
	local d=0;
	local r=0;
	local h=0;
	local ps=0;

	Perl_Raid_Grp1_NameFrame_NameBarText:SetText(PERL_LOC_CLASS_WARRIOR);
	Perl_Raid_Grp2_NameFrame_NameBarText:SetText(PERL_LOC_CLASS_MAGE);
	Perl_Raid_Grp3_NameFrame_NameBarText:SetText(PERL_LOC_CLASS_PRIEST);
	Perl_Raid_Grp4_NameFrame_NameBarText:SetText(PERL_LOC_CLASS_WARLOCK);
	Perl_Raid_Grp5_NameFrame_NameBarText:SetText(PERL_LOC_CLASS_DRUID);
	Perl_Raid_Grp6_NameFrame_NameBarText:SetText(PERL_LOC_CLASS_ROGUE);
	Perl_Raid_Grp7_NameFrame_NameBarText:SetText(PERL_LOC_CLASS_HUNTER);
	if (UnitFactionGroup("player") == "Horde") then
		Perl_Raid_Grp8_NameFrame_NameBarText:SetText(PERL_LOC_CLASS_SHAMAN);
	else
		Perl_Raid_Grp8_NameFrame_NameBarText:SetText(PERL_LOC_CLASS_PALADIN);
	end

	for num=1,40 do
		local frame = getglobal("Perl_Raid"..num);

		if (UnitClass("raid"..num)==PERL_LOC_CLASS_WARRIOR) then
			wpos=wpos+1;
			frame:SetPoint("TOPLEFT", Perl_Raid_Grp1, "BOTTOMLEFT", 0,(2-(wa*44)));
			wa=wa+1;

			if (wa < 10) then
				if (Perl_Config.ShowGroup9) then
					local warFrame = getglobal("Perl_Raid"..(wa + 40));

					warFrame.partyid = "raid"..num.."target";
					warFrame.parentid = "raid"..num;
					warFrame.showing = true;
				end
			end
			frame.showing = Perl_Config.ShowGroup1;

		elseif (UnitClass("raid"..num)==PERL_LOC_CLASS_MAGE) then
			frame:SetPoint("TOPLEFT", Perl_Raid_Grp2, "BOTTOMLEFT", 0,(2-(m*44)));
			m=m+1;
			frame.showing = Perl_Config.ShowGroup2;

		elseif (UnitClass("raid"..num)==PERL_LOC_CLASS_PRIEST) then
			frame:SetPoint("TOPLEFT", Perl_Raid_Grp3, "BOTTOMLEFT", 0,(2-(p*44)));
			p=p+1;
			frame.showing = Perl_Config.ShowGroup3;

		elseif (UnitClass("raid"..num)==PERL_LOC_CLASS_WARLOCK) then
			frame:SetPoint("TOPLEFT", Perl_Raid_Grp4, "BOTTOMLEFT", 0,(2-(wr*44)));
			wr=wr+1;
			frame.showing = Perl_Config.ShowGroup4;

		elseif (UnitClass("raid"..num)==PERL_LOC_CLASS_DRUID) then
			frame:SetPoint("TOPLEFT", Perl_Raid_Grp5, "BOTTOMLEFT", 0,(2-(d*44)));
			d=d+1;
			frame.showing = Perl_Config.ShowGroup5;

		elseif (UnitClass("raid"..num)==PERL_LOC_CLASS_ROGUE) then
			frame:SetPoint("TOPLEFT", Perl_Raid_Grp6, "BOTTOMLEFT", 0,(2-(r*44)));
			r=r+1;
			frame.showing = Perl_Config.ShowGroup6;

		elseif (UnitClass("raid"..num)==PERL_LOC_CLASS_HUNTER) then
			frame:SetPoint("TOPLEFT", Perl_Raid_Grp7, "BOTTOMLEFT", 0,(2-(h*44)));
			h=h+1;
			frame.showing = Perl_Config.ShowGroup7;

		elseif (UnitClass("raid"..num)==PERL_LOC_CLASS_PALADIN or UnitClass("raid"..num)==PERL_LOC_CLASS_SHAMAN) then
			frame:SetPoint("TOPLEFT", Perl_Raid_Grp8, "BOTTOMLEFT", 0,(2-(ps*44)));
			ps=ps+1;
			frame.showing = Perl_Config.ShowGroup8;
		else
			frame.showing = 0;
		end
	end
end
function Perl_Raid_Groups()
	local wpos=1;

	for i = 1,8 do
		getglobal("Perl_Raid_Grp"..i.."_NameFrame_NameBarText"):SetText("Group "..i);
	end

	local counts = {0,0,0,0,0,0,0,0};
	for num=1,40 do
		local frame = getglobal("Perl_Raid"..num);

		if (frame) then
			local name, rank, subgroup= GetRaidRosterInfo(num);
			if (name and subgroup) then
				if (UnitClass("raid"..num) == PERL_LOC_CLASS_WARRIOR) then
					if (Perl_Config.ShowGroup9) then
						if (wpos < 10) then
							local warFrame = getglobal("Perl_Raid"..(40 + wpos));
							warFrame.partyid = "raid"..num.."target";
							warFrame.parentid = "raid"..num;
							warFrame.showing = true;
						end
					end
					wpos=wpos+1;
				end

				if (name and subgroup and subgroup >= 1 and subgroup <= 8) then
					frame:SetPoint("TOPLEFT", "Perl_Raid_Grp"..subgroup, "BOTTOMLEFT", 0,(2-(counts[subgroup]*44)));
					counts[subgroup] = counts[subgroup] + 1;
					frame.showing = Perl_Config["ShowGroup"..subgroup];
				else
				    	frame.showing = 0;
				end
			else
				frame.showing = 0;
			end
		end
	end
end
--------------------
-- Click Handlers --
--------------------
local function Perl_Raid_FindID(object)
	local _, _, num = string.find(object:GetName(), "(%d+)")
	return tonumber(num);
end

local function Perl_Raid_FindNum(partyid)
	local _, _, num = string.find(partyid, "(%d+)")
	return tonumber(num);
end

function Perl_Raid_OnClick(button)
	local id = Perl_Raid_FindID(this);
	local unitid = "raid"..id;

	if (id > 40) then
		local thisFrame = Perl_Raid_Frame.Array[unitid];
		if (thisFrame) then
			unitid = thisFrame.parentid.."target";
		else
			return;
		end
	end

	if (Perl_CustomClickFunction(button, unitid)) then
		return;
	end

	if (CastParty_constants and (Perl_Config.CastParty==1) and (id<=40)) then
		this:SetID(id+4);
		CastParty_OnClick(button);
		this:SetID(id);
	end

	if (button == "RightButton" and SpellIsTargeting()) then
		SpellStopTargeting();
		return;
	end

	if (button == "LeftButton") then
		if ( SpellIsTargeting() ) then
			SpellTargetUnit(unitid);
		elseif ( CursorHasItem() ) then
			DropItemOnUnit(unitid);
		else
			TargetUnit(unitid);
		end
	else
		ToggleDropDownMenu(1, nil, getglobal("Perl_Raid"..id.."_DropDown"), "Perl_Raid"..id.."_StatsFrame_CastClickOverlay", 0, 0);
	end
end

function Perl_Raid_PlayerTip()
	local id = this:GetID();
	if (id == 0) then
		id = Perl_Raid_FindID(this);
		this:SetID(id);
	end

	if (id) then
		local unitid = "raid"..id;
		--GameTooltip_SetDefaultAnchor(GameTooltip, this);
		--GameTooltip:SetUnit(unitid);

		Perl_PlayerTip(unitid);
	end

        Perl_Options_SelectFrame("raid");
end

function Perl_ScaleRaid(num)
	for frame=1,9 do
		getglobal("Perl_Raid_Grp"..frame):SetScale(num);
	end
	for frame=1,50 do
		getglobal("Perl_Raid"..frame):SetScale(num);
	end
end

function Perl_RaidTitles()
	if perl_locked==1 then
		for num=1,9 do
	 		getglobal("Perl_Raid_Grp"..num):Hide();
		end
	else
		for num=1,9 do
			getglobal("Perl_Raid_Grp"..num):Show();
		end
	end
end

function Perl_RaidDropDown_Initialize()
	local id = this:GetID();
	if (id == 0) then
		id = Perl_Raid_FindID(this);
		this:SetID(id);
	end

	local dropdown;

	if ( UIDROPDOWNMENU_OPEN_MENU ) then
		dropdown = getglobal(UIDROPDOWNMENU_OPEN_MENU);
	else
		dropdown = this;
	end

	if (CT_RATab_newRaidFrameDropDown_Initialize and UIDROPDOWNMENU_OPEN_MENU) then
		this.unit = "raid"..id;
		this.name = UnitName(this.unit);
		this.id = id;
		CT_RATab_newRaidFrameDropDown_Initialize();
	else
		UnitPopup_ShowMenu(dropdown, "RAID", "raid"..id, UnitName("raid"..id), id);
	end
end

function Perl_RaidDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, Perl_RaidDropDown_Initialize, "MENU");
end


-- Moving stuff
function Perl_Raid_GetGap()
	local a = Perl_Raid_Grp2:GetLeft() - Perl_Raid_Grp1:GetRight();

	a = a + 0.01;
	a = a * 100;
	a = math.floor (a);
	a = a / 100;

	return (math.floor(a + 6));
end

function Perl_Raid_SetGap(newGap)
	if (type(newGap) == "number") then
		newGap = newGap - 6;
		for i = 2,8 do
			local frame1 = getglobal("Perl_Raid_Grp"..(i - 1));
			local frame2 = getglobal("Perl_Raid_Grp"..i);

			local top1 = frame1:GetTop();
			local top2 = frame2:GetTop();

			frame2:ClearAllPoints();
			frame2:SetPoint("TOPLEFT", frame1, "TOPRIGHT", newGap, (top2 - top1));

			Perl_Raid_Grp1:SaveAllPositions();
		end
	end
end

function Perl_Raid_AlignTop()
	for i = 2,8 do
		local frame1 = getglobal("Perl_Raid_Grp"..(i - 1));
		local frame2 = getglobal("Perl_Raid_Grp"..i);

		local gap = frame2:GetLeft() - frame1:GetRight();

		frame2:ClearAllPoints();
		frame2:SetPoint("TOPLEFT", frame1, "TOPRIGHT", gap, 0);

		Perl_Raid_Grp1:SaveAllPositions();
	end
end

function Perl_SetupRaidFrames()
	if (getglobal("Perl_Raid40")) then
		for num = 1,50 do
	                Perl_SetupFrame(getglobal("Perl_Raid"..num.."_StatsFrame"));
	                Perl_SetupFrame(getglobal("Perl_Raid"..num.."_NameFrame"));

			if (Perl_Config.HighlightSelection == 1) then
				getglobal("Perl_Raid"..num.."_StatsFrame_CastClickOverlay"):SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight2x1", "ADD");
			else
				getglobal("Perl_Raid"..num.."_StatsFrame_CastClickOverlay"):SetHighlightTexture("");
		        end
		end
	end
end
